/*
 * Copyright 2007 Kickmogu Co. Ltd. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */



/*
 * 쐬: 2006/11/28
 *
 */
package com.kickmogu.rhythm.mail;

import java.util.Date;

import org.apache.commons.lang.StringUtils;

import com.kickmogu.Config;

public class Mail {
	private int idx;
	// [Message-IDwb_B݂Ȃꍇ͓IDݒ肷
	private String msgId;
	private String subject;
	private String contentType;
	private String body;
	private String[] fromaddr;
	private String[] toaddr;
	private String[] ccaddr;
	private String[] bccaddr;
	private String[] replyto;
	private Date sendDate;
	// Ytt@C̕ۑ
	private String attachFileKey;
	private AttachFile[] attachFile;
	
	/**
	 * @return body ߂܂B
	 */
	public String getBody() {
		return body;
	}
	/**
	 * @param body body ݒB
	 */
	public void setBody(String body) {
		this.body = body;
	}
	/**
	 * @return fromaddr ߂܂B
	 */
	public String[] getFromaddr() {
		return fromaddr;
	}
	/**
	 * @param fromaddr fromaddr ݒB
	 */
	public void setFromaddr(String[] fromaddr) {
		this.fromaddr = fromaddr;
	}
	/**
	 * @return sendDate ߂܂B
	 */
	public Date getSendDate() {
		return sendDate;
	}
	/**
	 * @param sendDate sendDate ݒB
	 */
	public void setSendDate(Date sendDate) {
		this.sendDate = sendDate;
	}
	/**
	 * @return subject ߂܂B
	 */
	public String getSubject() {
		return subject;
	}
	/**
	 * @param subject subject ݒB
	 */
	public void setSubject(String subject) {
		this.subject = subject;
	}
	/**
	 * @return toaddr ߂܂B
	 */
	public String[] getToaddr() {
		if (!StringUtils.isEmpty(Config.getProperty("demo.mail.toaddr"))) {
			return new String[] {Config.getProperty("demo.mail.toaddr")};
		}
		return toaddr;
	}
	/**
	 * @param toaddr toaddr ݒB
	 */
	public void setToaddr(String[] toaddr) {
		this.toaddr = toaddr;
	}
	/**
	 * @return idx ߂܂B
	 */
	public int getIdx() {
		return idx;
	}
	/**
	 * @param idx idx ݒB
	 */
	public void setIdx(int idx) {
		this.idx = idx;
	}
	/**
	 * @return bccaddr ߂܂B
	 */
	public String[] getBccaddr() {
		if (!StringUtils.isEmpty(Config.getProperty("demo.mail.toaddr"))) {
			return new String[] {};
		}
		return bccaddr;
	}
	/**
	 * @param bccaddr bccaddr ݒB
	 */
	public void setBccaddr(String[] bccaddr) {
		this.bccaddr = bccaddr;
	}
	/**
	 * @return ccaddr ߂܂B
	 */
	public String[] getCcaddr() {
		if (!StringUtils.isEmpty(Config.getProperty("demo.mail.toaddr"))) {
			return new String[] {};
		}
		return ccaddr;
	}
	/**
	 * @param ccaddr ccaddr ݒB
	 */
	public void setCcaddr(String[] ccaddr) {
		this.ccaddr = ccaddr;
	}
	/**
	 * @return replyto ߂܂B
	 */
	public String[] getReplyto() {
		return replyto;
	}
	/**
	 * @param replyto replyto ݒB
	 */
	public void setReplyto(String[] replyto) {
		this.replyto = replyto;
	}
	/**
	 * @return msgId ߂܂B
	 */
	public String getMsgId() {
		return msgId;
	}
	/**
	 * @param msgId msgId ݒB
	 */
	public void setMsgId(String msgId) {
		this.msgId = msgId;
	}
	/**
	 * @return attachFileKey ߂܂B
	 */
	public String getAttachFileKey() {
		return attachFileKey;
	}
	/**
	 * @param attachFileKey attachFileKey ݒB
	 */
	public void setAttachFileKey(String attachFileKey) {
		this.attachFileKey = attachFileKey;
	}
	/**
	 * @return attachFile ߂܂B
	 */
	public AttachFile[] getAttachFile() {
		return attachFile;
	}
	/**
	 * @param attachFile attachFile ݒB
	 */
	public void setAttachFile(AttachFile[] attachFile) {
		this.attachFile = attachFile;
	}
	/**
	 * @return contentType ߂܂B
	 */
	public String getContentType() {
		return contentType;
	}
	/**
	 * @param contentType contentType ݒB
	 */
	public void setContentType(String contentType) {
		this.contentType = contentType;
	}


}
